
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>

int main(int argc, char* argv[]) {

    struct termios serial;
    char rON[3] = {0xFF,0x01,0x01};
    char rOFF[3] = {0xFF,0x01,0x00};	
    char status[3] = {0xFF,0x01,0x03};
    char inBuff[16];
    char *buffer;
    char choice[5];
  
    if (argc == 1) {
        printf("Usage: %s [device]\n\n", argv[0]);
        return -1;
    }
   
    strcpy(choice,argv[1]);
    printf("Opening %s\n", argv[2]);

    int fd = open(argv[2], O_RDWR | O_NOCTTY | O_NDELAY);

    if (fd == -1) {
        perror(argv[2]);
        return -1;
    }

    if (tcgetattr(fd, &serial) < 0) {
        perror("Getting configuration");
        return -1;
    }

    // Set up Serial Configuration
    serial.c_iflag = 0;
    serial.c_oflag = 0;
    serial.c_lflag = 0;
    serial.c_cflag = 0;

    serial.c_cc[VMIN] = 0;
    serial.c_cc[VTIME] = 10;

    serial.c_cflag = B9600 | CS8 | CREAD;
    fcntl(fd,F_SETFL,0);
    tcsetattr(fd, TCSANOW, &serial); // Apply configuration

    int wcount = 0;
    switch(choice[1])
    {
    	case('n'):
	  wcount = write(fd, rON, sizeof(rON));
	  break;	
        case('f'):
	  wcount = write(fd, rOFF, sizeof(rOFF));
	  break;
        case('s'):
	  wcount = write(fd, status, sizeof(status));
	  break;
    }

    if (wcount < 0) {
        perror("Write");
        return -1;
    }
    
   int rcount;  
   buffer = &inBuff[0];	
   if(choice[1] == 's')
   {
		while( (rcount = read(fd,buffer,1)) > 0)
		{
       
   	 	if (rcount < 0) {
        	perror("Read");
       		return -1;
   		 }

      		buffer++;
        }

    	printf("%02x %02x %02x \r\n",inBuff[0],inBuff[1],inBuff[2]);
      }
    close(fd);
}
